-- simple lua queue implementation
function Queue_new()
    return {first = -1, last = 0}
end

function Queue_empty(list) 
	return (list.first < list.last)
end    

function Queue_push(list, value)
	-- do not add nil values to list
	if (value == nil) then
		return
    end
    
    -- add value at end
    local last = list.last - 1
    list.last = last
    list[last] = value
end

function Queue_size(list) 
	if (Queue_empty(list)) then
		return 0
	else 
		return -(list.last - list.first) + 1
	end
end

function Queue_pop(list)
	if (Queue_empty(list)) then
	  return nil;
	end
	local curFirst = list.first
    local value = list[curFirst]
    list[curFirst] = nil        
    list.first = curFirst - 1
    return value
end 